POJ训练计划3126_Prime Path(素数+BFS)

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 10692 Accepted: 6089

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source


解题报告

BFS的题,一开始不知道哪里错了,调了一会就不调了,回宿舍重新敲1A。。。

题意很容易理解,从一个数到另一个数的最短路径,要求走的是素数。。。

预判一下素数,接下就是BFS的事

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <queue>
using namespace std;
int s,e;
int is_prime[10001],vis[10001];
int change(int x,int i,int j)
{
    if(i==1)return x/10*10+j;
    else if(i==2)return x/100*100+j*10+x%10;
    else if(i==3)return x/1000*1000+j*100+x%100;
    else if(i==4)return j*1000+x%1000;
}
struct node
{
    int x,step;
};
void bfs(int s,int e)
{
    memset(vis,0,sizeof(vis));
    queue<node>Q;
    node now,next;
    now.x=s;
    now.step=0;
    vis[s]=1;
    Q.push(now);
    while(!Q.empty())
    {
        now=Q.front();
        Q.pop();
        if(now.x==e)
        {
            cout<<now.step<<endl;
            return ;

        }
        for(int i=1;i<=4;i++)
        {
            for(int j=0;j<10;j++)
            {
                if(!(i==4&&j==0))
                {
                    next.x=change(now.x,i,j);
                    if(!vis[next.x]&&!is_prime[next.x])
                    {
                        next.step=now.step+1;
                        vis[next.x]=1;
                        Q.push(next);
                    }
                }
            }
        }
    }
}
int main()
{
    is_prime[0]=1;
    is_prime[1]=1;
    for(int i=2;i<10000;i++)
    {
        if(!is_prime[i])
            for(int j=i*i;j<10000;j+=i)
                is_prime[j]=1;
    }
    int n;
    cin>>n;
    while(n--)
    {
        cin>>s>>e;
        bfs(s,e);
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给定两个长度均为 $n$ 的数组 $A,B$,其中 $A$ 数组中的元素两两不同,$B$ 数组中元素也两两不同。 定义 $A$ 数组的第 $i$ 个元素为 $a_i$,$B$ 数组的第 $i$ 个元素为 $b_i$。定义一个四元组 $(i,j,k,l)$ 符合条件当且仅当 $1 \leq i < j \leq n$,$1 \leq k < l \leq n$,$$ a_i+b_j=k+l $$ 问有多少个符合条件的四元组。 输入 输入的第一行为一个整数 $n$,表示 $A$ 和 $B$ 数组的长度。 接下来 $n$ 行,第 $i$ 行包含两个整数 $A_i$ 和 $B_i$。 输出 输出一行,一个整数,表示符合条件的四元组个数。 输入样例 3 1 1 2 2 3 3 输出样例 6 提示 $1 \leq n \leq 1500$,$1 \leq A_i,B_i \leq 10^9$ 这一题要求解符合条件的四元组。其中有一个直观的想法就是将四元组分类讨论,如下所示: $$a_i + b_j = k + l$$ 分类讨论,当 $i < k, j < l$ 时就是一种方案,当 $i > k, j > l$ 时是另一种情况。 因此,对于每一种 $a_i + b_j$ 的和,记录下它的出现次数,同时记录下这个和所对应的 $i, j$ 的值。在计算的过程中,如果遇到相同的和的时候,再次遇到时是可以直接忽略的,因为等式是对称的。 统计符合条件的四元组当然要对和进行枚举,但是值得注意的是,在构造符合条件的 $k, l$ 的时候,数组 $C$ 和 $D$ 的记录顺序是无关紧要的,因为等式 $a_i + b_j = k + l$ 已经将每个数字都制约了,它们可以出现任意的顺序。因此,在统计 $C$ 和 $D$ 对于计算答案来说是无区别的。 这一题值得特别注意的是,当数组中有数据的时候,要注意考虑到数据越界可能导致结果错误。在本题中,由于 $a_i, b_j$ 的上限是 $10^9$,因此 $a_i + b_j$ 的上限最大可能会达到 $2 \times 10^9$,因此在计算时一定要使用 long long 类型,否则很容易产生错误。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值